/***************************************************************************
 *   Copyright (C) 2006 by Peter Komar                                     *
 *   markus_sksoft@mail.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//
#include "dmmain.h"

#include <qfile.h>
#include <qtextstream.h>
#include <qstring.h>
#include <qradiobutton.h>
#include <qmessagebox.h>
#include <qlineedit.h>

char str[] = "/etc/sysconfig/desktop";
char strSuse[] = "/etc/sysconfig/displaymanager";

DmMain::DmMain(QWidget *parent, const char *name)
    :DmWidget(parent, name)
{
  loadData();
}

void DmMain::slotFinish()
{
	if(!modeDM)
	{
	  switch(i)
	  {
		 case 0: name = "KDE"; break;
		 case 1: name = "GNOME"; break;
		 case 2: name = "XDM"; break;
		 case 3: name = linedm->text(); break;
		 default: name = "GNOME";
	  }
	}
	else if(modeDM == 1)
	{
		switch(i)
		{
			case 0: name = "kdm"; break;
			case 1: name = "gdm"; break;
			case 2: name = "xdm"; break;
			case 3: name = linedm->text(); break;
			default: name = "gdm";
		}
	}
	
	
	QString glob;
	QFile file;
			
	if(!modeDM)
	  file.setName(str);
	else if(modeDM == 1)
		file.setName(strSuse);
	
	if ( file.open( IO_ReadOnly ) ) {
		QTextStream stream( &file );
		QString line;
		while ( !stream.atEnd() ) {
			line = stream.readLine();
			if(!modeDM)
			{
				if(line.find("DESKTOP=")!=-1)
					line = QString("DESKTOP=\"%1\"").arg(name);
			}
			else if(modeDM == 1)
			{
				if(line.find("DISPLAYMANAGER=")!=-1)
					line = QString("DISPLAYMANAGER=\"%1\"").arg(name);
			}
			glob += line+"\n";
		}
		file.close();
	}
	
	if ( file.open( IO_WriteOnly ) ) {
		QTextStream stream( &file );
		stream << glob;
		file.close();
	}
  
  close();
}

void DmMain::slotSelect(int n)
{
  i = n;
}




/*!
    \fn myDmMain::loadData()
 */
void DmMain::loadData()
{
  QFile f(str);
	modeDM = 0;
	
	if(!f.exists())
	{
		f.setName( strSuse );
		if(f.exists())
			modeDM = 1;
	}
 
  QString line, tmp;
  int n = 1, i, j;
  
  if (f.open(IO_ReadOnly)) {
    QTextStream stream(&f);
    
    
    while ( !stream.atEnd() ) {
      line = stream.readLine()+"\n";
      
		if(!modeDM)
		{
			i = line.find("DESKTOP=");
			
			if(i == -1)
				continue;
			
			j = line.find("=", i+1);
			if(j == -1)
				continue;
			
			tmp = line.mid(j+1, line.find("\n"));
			if(tmp.find("\"")!=-1)
			{
				tmp.remove(0,1);
				tmp.remove(tmp.length()-2,2); //removes char \"
			}
			else
				tmp.remove(tmp.length()-1,1); //removes char \n
			
      if(tmp == "KDE")
       n=0;
      else if(tmp == "GNOME")
       n=1;
      else if(tmp == "XDM")
        n=2;
      else
       n=3;
			break;
    }
		else
			if(modeDM == 1)
		  {
				i = line.find("DISPLAYMANAGER=");
			
				if(i == -1)
					continue;
			
				j = line.find("=", i+1);
				if(j == -1)
					continue;
			
				tmp = line.mid(j+1, line.find("\n"));
				if(tmp.find("\"")!=-1)
				{
					tmp.remove(0,1);
					tmp.remove(tmp.length()-2,2); //removes char \"
				}
				else
					tmp.remove(tmp.length()-1,1); //removes char \n
			
				if(tmp == "kdm")
					n=0;
				else if(tmp == "gdm")
					n=1;
				else if(tmp == "xdm")
					n=2;
				else
					n=3;
				break;
			}
			
		}
		f.close();
   
 }
  
   
 switch(n)
  {
    case 0: KdmBtn->setChecked(true); break;
    case 1: GdmBtn->setChecked(true); break;
    case 2: XdmBtn->setChecked(true); break;
		case 3: otherBtn->setChecked(true); linedm->setText(tmp); break;
    default : GdmBtn->setChecked(true); 
  }
}
